#include"field.hpp"




namespace{


int
phase;


Point3D  tmp_a;
Point3D  tmp_b;


}


Field::
Field()
{
  thumbnail.resize(0,0);

  root_nodes.emplace_back(doll.waist);
/*
auto  a = new Node;
auto  b = new Node;
auto  c = new Node;

a->append(*b);
//b->append(*c);
const int  v = 30;
a->make(v,v,v);
b->make(v,v,v);
//c->make(v,v,v);

a->source.offset.z = 200;
b->source.offset.x =  v/2;
b->source.offset.y = -v/2;
//c->source.offset.x = v;
root_nodes.emplace_back(a);
*/
}


Field::
~Field()
{
    for(auto&  ptr: root_nodes)
    {
//      ptr->print();

      delete ptr;
    }
}




void
Field::
put()
{
  switch(phase)
  {
     case(0):
      tmp_a = cursor_point;
      ++phase;
      break;
    case(1):
      tmp_b = cursor_point;
      ++phase;
      break;
    case(2):
      
      phase = 0;
      break;
  }
}


void
Field::
unput()
{
    switch(phase)
    {
      case(0):
       
        break;
      case(1):
        --phase;
        break;
      case(2):
        --phase;
        break;
    }
}


bool
Field::
process(const Controller&  ctrl)
{
  constexpr int  v = 16;

    if(ctrl.test_pressing(Key::shift_flag))
    {
           if(ctrl.test_pressing(Key::down_flag)){cursor_point.z += v;}
      else if(ctrl.test_pressing(Key::up_flag  )){cursor_point.z -= v;}
    }

  else
    if(ctrl.test_pressing(Key::start_flag))
    {
      return true;
    }

  else
    {
           if(ctrl.test_pressing(Key::up_flag   )){cursor_point.y -= v;}
      else if(ctrl.test_pressing(Key::left_flag )){cursor_point.x -= v;}
      else if(ctrl.test_pressing(Key::right_flag)){cursor_point.x += v;}
      else if(ctrl.test_pressing(Key::down_flag )){cursor_point.y += v;}
      else if(ctrl.test_pressing(Key::p_flag)){  put();}
      else if(ctrl.test_pressing(Key::n_flag)){unput();}
    }


  return false;
}




void
Field::
transfer() const
{
  FieldRenderer::clear();

    for(auto  ptr: root_nodes)
    {
      ptr->write_as_root();
    }
}


void
Field::
draw(Drawer&  dr, void*  data, int  item_index, int  x, int  y)
{
  auto&  fld = *(static_cast<const Field*>(data)+item_index);

  dr.draw_rect(0xFFFFFFFF,0,0,get_rendparam().width,get_rendparam().height);

/*
    {
      auto&  a_pt = fld.cursor_point;

      dr.draw_formatted(0xFFFFFFFF,0,          0,"X %3d",a_pt.x);
      dr.draw_formatted(0xFFFFFFFF,0,font_size  ,"Y %3d",a_pt.y);
      dr.draw_formatted(0xFFFFFFFF,0,font_size*2,"Z %3d",a_pt.z);
    }
*/
}




