#ifndef SINCOS_HPP_INCLUDED
#define SINCOS_HPP_INCLUDED


#include"imp.hpp"


void  get_sincos(int  degree, int&  sin_value, int&  cos_value);



struct
RotationParameter
{
  Point3D  center;

  int  x_degree=0;
  int  y_degree=0;
  int  z_degree=0;

};


void  rotate_x(Point3D&  pt, const RotationParameter&  param);
void  rotate_y(Point3D&  pt, const RotationParameter&  param);
void  rotate_z(Point3D&  pt, const RotationParameter&  param);

void  rotate(Point3D&  pt, const RotationParameter&  param);




#endif




